"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getApiKey = exports.deleteApiKey = exports.saveApiKey = exports.getCustomUrl = exports.saveCustomUrl = exports.decrypt = exports.encrypt = void 0;
const fs = __importStar(require("fs"));
const crypto = __importStar(require("crypto"));
const algorithm = "aes-256-cbc";
const secretKey = "terminalGPT";
function encrypt(text) {
    const iv = crypto.randomBytes(16);
    const key = crypto.scryptSync(secretKey, "salt", 32);
    const cipher = crypto.createCipheriv(algorithm, key, iv);
    let encrypted = cipher.update(text);
    encrypted = Buffer.concat([encrypted, cipher.final()]);
    return iv.toString("hex") + ":" + encrypted.toString("hex");
}
exports.encrypt = encrypt;
function decrypt(text) {
    const textParts = text.split(":");
    const iv = Buffer.from(textParts.shift(), "hex");
    const encryptedText = Buffer.from(textParts.join(":"), "hex");
    const key = crypto.scryptSync(secretKey, "salt", 32);
    const decipher = crypto.createDecipheriv(algorithm, key, iv);
    let decrypted = decipher.update(encryptedText);
    decrypted = Buffer.concat([decrypted, decipher.final()]);
    return decrypted.toString();
}
exports.decrypt = decrypt;
function saveCustomUrl(url) {
    if (url === undefined) {
        fs.unlinkSync(`${__dirname}/customUrl.txt`);
    }
    else {
        fs.writeFileSync(`${__dirname}/customUrl.txt`, url);
    }
}
exports.saveCustomUrl = saveCustomUrl;
function getCustomUrl() {
    if (fs.existsSync(`${__dirname}/customUrl.txt`)) {
        return fs.readFileSync(`${__dirname}/customUrl.txt`, "utf8");
    }
    return undefined;
}
exports.getCustomUrl = getCustomUrl;
function saveApiKey(apiKey) {
    fs.writeFileSync(`${__dirname}/apiKey.txt`, apiKey);
}
exports.saveApiKey = saveApiKey;
function deleteApiKey() {
    fs.unlinkSync(`${__dirname}/apiKey.txt`);
}
exports.deleteApiKey = deleteApiKey;
function getApiKey() {
    if (fs.existsSync(`${__dirname}/apiKey.txt`)) {
        const getEncryptedScript = fs.readFileSync(`${__dirname}/apiKey.txt`, "utf8");
        return decrypt(getEncryptedScript);
    }
    return null;
}
exports.getApiKey = getApiKey;
